$(function() {
	window.IM = window.IM || {
		_appid: '8a48b5515427d276015436d27cbf1616', // 应用ID
		_onUnitAccount: 'KF10089', // 多渠道客服帐号，目前只支持1个
		_3rdServer: 'http://123.57.230.158:8886/authen/', // 3rdServer，主要用来虚拟用户服务器获取SIG

		/** 以下不要动，不需要改动 */
		_timeoutkey: null,
		_username: user.NAME,
		_user_account: user.USERNAME,
		_contact_type_c: 'C', // 代表联系人
		_contact_type_g: 'G', // 代表群组
		_contact_type_m: 'M', // 代表多渠道客服
		_onMsgReceiveListener: null,
		_onDeskMsgReceiveListener: null,
		_noticeReceiveListener: null,
		_onConnectStateChangeLisenter: null,
		_onCallMsgListener: null,
		_isMcm_active: false,
		_local_historyver: 0,
		_msgId: null, // 消息ID，查看图片时有用
		_pre_range: null, // pre的光标监控对象
		_pre_range_num: 0, // 计数，记录pre中当前光标位置，以childNodes为单位
		_fireMessage: 'fireMessage',
		_serverNo: 'XTOZ',
		_baiduMap: null,
		_loginType: 1, //登录类型: 1账号登录，3voip账号密码登录
		_Notification: null,

		/**
		 * 初始化
		 */
		init: function() {
			var resp = RL_YTX.init(IM._appid);
			if (!resp) {
				console.error("聊天初始化错误");
				return;
			};
			if (200 == resp.code) { // 初始化成功
				IM.DO_login(IM._user_account, '');
			} else if (174001 == resp.code) { // 不支持HTML5
			} else if (170002 == resp.code) { //缺少必须参数
				console.error("错误码：170002,错误码描述" + resp.msg);
			} else {
				console.error('未知状态码');
			};
		},
		/**
		 * 正式处理登录逻辑，此方法可供断线监听回调登录使用 获取时间戳，获取SIG，调用SDK登录方法
		 * 
		 * @param user_account
		 * @param pwd 密码
		 * @private
		 */
		DO_login: function(user_account, pwd) {
			var timestamp = IM._getTimeStamp();

			var flag = false; //是否从第三方服务器获取sig
			if (flag) {
				IM._privateLogin(user_account, timestamp, function(obj) {
					console.log('obj.sig:' + obj.sig);
					IM.EV_login(user_account, pwd, obj.sig, timestamp);
				}, function(obj) {
					$('#navbar_user_account').removeAttr("readonly");
					console.error("错误码：" + obj.code + "; 错误描述：" + obj.msg);
				});
			} else {
				//仅用于本地测试，官方不推荐这种方式应用在生产环境
				//没有服务器获取sig值时，可以使用如下代码获取sig
				var appToken = '90090ae504cdc4e7b8d4be44b7de30ed'; //使用是赋值为应用对应的appToken
				var sig = hex_md5(IM._appid + user_account + timestamp + appToken);
				console.log("本地计算sig：" + sig);
				IM.EV_login(user_account, pwd, sig, timestamp);
			}
		},
		/**
		 * SIG获取 去第三方（客服）服务器获取SIG信息 并将SIG返回，传给SDK中的登录方法做登录使用
		 * 
		 * @param user_account
		 * @param timestamp -- 时间戳要与SDK登录方法中使用的时间戳一致
		 * @param callback
		 * @param onError
		 * @private
		 */
		_privateLogin: function(user_account, timestamp, callback, onError) {
			console.log("_privateLogin");
			var data = {
				"appid": IM._appid,
				"username": user_account,
				"timestamp": timestamp
			};
			var url = IM._3rdServer + 'genSig';
			$.ajax({
				url: url,
				dataType: 'jsonp',
				data: data,
				jsonp: 'cb',
				success: function(result) {
					if (result.code != 000000) {
						var resp = {};
						resp.code = result.code;
						resp.msg = "Get SIG fail from 3rd server!...";
						onError(resp);
						return;
					} else {
						var resp = {};
						resp.code = result.code;
						resp.sig = result.sig;
						callback(resp);
						return;
					}
				},
				error: function() {
					var resp = {};
					resp.msg = 'Get SIG fail from 3rd server!';
					onError(resp);
				},
				timeout: 5000
			});
		},

		/**
		 * 事件，登录 去SDK中请求登录
		 * 
		 * @param user_account
		 * @param sig
		 * @param timestamp --
		 *            时间戳要与生成SIG参数的时间戳保持一致
		 * @constructor
		 */
		EV_login: function(user_account, pwd, sig, timestamp) {
			console.log("EV_login");
			var loginBuilder = new RL_YTX.LoginBuilder();
			loginBuilder.setType(IM._loginType);
			loginBuilder.setUserName(user_account);
			if (1 == IM._loginType) { //1是自定义账号，3是voip账号
				loginBuilder.setSig(sig);
			} else {
				loginBuilder.setPwd(pwd);
			}
			loginBuilder.setTimestamp(timestamp);
			RL_YTX.login(loginBuilder, function(obj) {
				console.log("EV_login succ...");
				// 注册PUSH监听
				IM._onMsgReceiveListener = RL_YTX.onMsgReceiveListener(
					function(obj) {
						IM.EV_onMsgReceiveListener(obj);
					});
			}, function(obj) {
				console.error("错误码： " + obj.code + "; 错误描述：" + obj.msg);
			});
		},

		/**
		 * 获取当前时间戳 YYYYMMddHHmmss
		 * 
		 * @returns {*}
		 */
		_getTimeStamp: function() {
			var now = new Date();
			var timestamp = now.getFullYear() + '' + ((now.getMonth() + 1) >= 10 ? "" + (now.getMonth() + 1) : "0" + (now.getMonth() + 1)) + (now.getDate() >= 10 ? now.getDate() : "0" + now.getDate()) + (now.getHours() >= 10 ? now.getHours() : "0" + now.getHours()) + (now.getMinutes() >= 10 ? now.getMinutes() : "0" + now.getMinutes()) + (now.getSeconds() >= 10 ? now.getSeconds() : "0" + now.getSeconds());
			return timestamp;
		},

		/**
		 * 事件，创建群组
		 * 
		 * @param groupName
		 * @param permission
		 * @constructor
		 */
		EV_createGroup: function(groupName, permission) {
			console.log('create group...groupName[' + groupName + '] permission[' + permission + ']');
			var obj = new RL_YTX.CreateGroupBuilder();
			obj.setGroupName(groupName);
			obj.setPermission(permission);
			obj.setGroupType("1");
			RL_YTX.createGroup(obj, function(obj) {
				//alert(JSON.stringify(obj));
				var groupId = obj.data;

				console.log('create group succ... groupId[' + groupId + ']');

			}, function(obj) {
				console.error("错误码： " + obj.code + "; 错误描述：" + obj.msg);
				return;
			});

		},

		/**
		 * 加入群组
		 */
		EV_joinGroup: function(groupId) {
			console.log("join group");
			var objBuilder = new RL_YTX.JoinGroupBuilder();
			objBuilder.setGroupId(groupId);
			RL_YTX.joinGroup(objBuilder, function(obj) {
				console.log("申请加入群组成功");
			}, function(obj) {
				console.error("错误码： " + obj.code + "; 错误描述：" + obj.msg);
				return;
			});
		},

		/**
		 * 事件，获取群组详情
		 * 
		 * @param groupId
		 * @param target
		 * @constructor
		 */
		EV_getGroupDetail: function(groupId, successCallBack) {
			console.log('get Group Detail...');
			var objBuilder = new RL_YTX.GetGroupDetailBuilder();
			objBuilder.setGroupId(groupId);

			RL_YTX.getGroupDetail(objBuilder, function(obj) {
				successCallBack(obj);
			}, function(obj) {
				console.error("错误码： " + obj.code + "; 错误描述：" + obj.msg);
			});
		},

		/**
		 * 事件，搜索群组
		 */
		EV_searchGroups: function(groupId, groupName, successCallBack) {
			var builder = new RL_YTX.SearchGroupsBuilder();
			if (!isEmpty(groupId)) {
				builder.setSearchType("1");
				builder.setKeywords(groupId);
			} else {
				if (!isEmpty(groupName)) {
					builder.setSearchType("2");
					builder.setKeywords(groupName);
				} else {

				}
			}

			RL_YTX.searchGroups(builder, function(resp) {
				successCallBack(resp);
			}, function(resp) {
				console.error("错误码： " + resp.code + "; 错误描述：" + resp.msg);
				return;
			});
		},

		/**
		 * 事件，获取群组成员列表
		 * 
		 * @param groupId
		 * @param isowner
		 * @param target
		 *            1 讨论组 2 群组
		 * @constructor
		 */
		EV_getGroupMemberList: function(groupId) {
			console.log('get Group Member List...');
			var obj = new RL_YTX.GetGroupMemberListBuilder();
			obj.setGroupId(groupId);
			obj.setPageSize(-1);

			RL_YTX.getGroupMemberList(obj, function(obj) {
				console.log('get Group Member List SUCC...');
				successCallBack(obj);
			}, function(obj) {
				console.error("错误码： " + obj.code + "; 错误描述：" + obj.msg);
			});
		},

		/**
		 * 事件，发送消息
		 * 
		 * @param msgid
		 * @param text
		 * @param receiver
		 * @param isresend
		 * @constructor
		 */
		EV_sendTextMsg: function(text, receiver) {
			console.log('send Text message: receiver:[' + receiver + ']...connent[' + text + ']...');

			var obj = new RL_YTX.MsgBuilder();
			obj.setText(text);
			obj.setType(1);
			obj.setReceiver(receiver);
			var msgId = RL_YTX.sendMsg(obj, function(obj) {
				console.log("消息发送成功");

			}, function(obj) {
				console.error("错误码： " + obj.code + "; 错误描述：" + obj.msg);
				return;
			});
		},

		/**
		 * 事件，push消息的监听器，被动接收信息
		 * 
		 * @param obj
		 * @constructor
		 */
		EV_onMsgReceiveListener: function(obj) {
			console.log('Receive message sender:[' + obj.msgSender + ']...msgId:[' + obj.msgId + ']...content[' + obj.msgContent + ']');
		},
	};

});