var slider = {
    //判断设备是否支持touch事件
    touch:('ontouchstart' in window) || window.DocumentTouch && document instanceof DocumentTouch,
    //slider:document.getElementById('content'),
    sliderID:"slider",
    
    //事件
    events:{
        index:0,     //显示元素的索引
        slider:this.slider,     //this为slider对象
        handleEvent:function(event){
        	this.slider = slider.getSlider();
            var self = this;     //this指events对象
            if(event.type == 'touchstart'){
                self.start(event);
            }else if(event.type == 'touchmove'){
                self.move(event);
            }else if(event.type == 'touchend'){
                self.end(event);
            }
        },
        //滑动开始
        start:function(event){
            var touch = event.targetTouches[0];     //touches数组对象获得屏幕上所有的touch，取第一个touch
            startPos = {x:touch.pageX,y:touch.pageY,time:+new Date};    //取第一个touch的坐标值
            isScrolling = 0;   //这个参数判断是垂直滚动还是水平滚动
            this.slider.addEventListener('touchmove',this,false);
            this.slider.addEventListener('touchend',this,false);
        },
        //移动
        move:function(event){
            //当屏幕有多个touch或者页面被缩放过，就不执行move操作
            if(event.targetTouches.length > 1 || event.scale && event.scale !== 1) return;
            var touch = event.targetTouches[0];
            endPos = {x:touch.pageX - startPos.x,y:touch.pageY - startPos.y};
            //console.log(JSON.stringify(endPos));
            isScrolling = Math.abs(endPos.x) < Math.abs(endPos.y) ? 1:0;    //isScrolling为1时，表示纵向滑动，0为横向滑动
            if(isScrolling === 0){
                event.preventDefault();      //阻止触摸事件的默认行为，即阻止滚屏
            }
            
            //执行回调
            slider.moving(endPos);
        },
        //滑动释放
        end:function(event){
        	slider.moving(0);
            var duration = +new Date - startPos.time;    //滑动的持续时间
            if(isScrolling === 0){    //当为水平滚动时
                if(Number(duration) > 10){     
                    //判断是左移还是右移，当偏移量大于10时执行
                    if(endPos.x > 10){
                    	
                    }else if(endPos.x < -10){
                    	
                    }
                }
            }
            //解绑事件
            this.slider.removeEventListener('touchmove',this,false);
            this.slider.removeEventListener('touchend',this,false);
        }
    },
    
    //顶部菜单透明
    moving:function(point) {
    	console.log("moving:");
    	slider.callback(point);
	},
    
    //初始化
    init:function(param){
        var self = this;     //this指slider对象
        var endPos;
        if(!!self.touch) {
        	if( param &&  self.isNull(param.id) == true ){
        		this.sliderID = param.id;
        	}
        	if( param &&  self.isNull(param.callback) == true ){
        		this.callback = param.callback;
        	}
        	self.slider = this.getSlider();
        	self.slider.addEventListener('touchstart',self.events,false);    //addEventListener第二个参数可以传一个对象，会调用该对象的handleEvent属性
        }
    },
    
    getSlider:function(){
    	return document.getElementById(this.sliderID);
    },
    
    callback:function(point){
    	console.log("callback"+JSON.stringify(point));
    },
    
    isNull:function(str){
    	if( str == null || str == undefined || str == "" ){
    		return false;
    	}   return true;
    }
    
};
		