/**0、判断访问终端**/
var browser={
    versions:function(){
        var u = navigator.userAgent, app = navigator.appVersion;
        return {
            trident: u.indexOf('Trident') > -1, //IE内核
            presto: u.indexOf('Presto') > -1, //opera内核
            webKit: u.indexOf('AppleWebKit') > -1, //苹果、谷歌内核
            gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') == -1,//火狐内核
            mobile: !!u.match(/AppleWebKit.*Mobile.*/), //是否为移动终端
            ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), //ios终端
            android: u.indexOf('Android') > -1 || u.indexOf('Adr') > -1, //android终端
            iPhone: u.indexOf('iPhone') > -1 , //是否为iPhone或者QQHD浏览器
            iPad: u.indexOf('iPad') > -1, //是否iPad
            webApp: u.indexOf('Safari') == -1, //是否web应该程序，没有头部与底部
            weixin: u.indexOf('MicroMessenger') > -1, //是否微信 （2015-01-22新增）
            qq: u.match(/\sQQ/i) == " qq" //是否QQ
        };
    }(),
    language:(navigator.browserLanguage || navigator.language).toLowerCase()
}

/**
 * 1、判断对象是否是字符串 
 * */
function isString(obj){
  return Object.prototype.toString.call(obj) === "[object String]";  
}  


/**
 * 2、缓存
 * */

//localStorage存值永久有效
function setStorage (key,val) {
	if( isString(val) ){
		localStorage.setItem(key,val);
	}else{
		localStorage.setItem(key,JSON.stringify(val));
	}
}

 //localStorage取值：（返回结果：JSON字符串）
function getStorage(key){
    return localStorage.getItem(key);
}

 //localStorage取值（返回结果：对象）
function getObjStorage(key){
    return JSON.parse(localStorage.getItem(key));
}

//localStorage删除指定键对应的值
function delStorage(key){
    localStorage.removeItem(key);
}


/**
 * 3、验证
 * */
//验证是否为空：返回boolean
function isNull(str){
    if( str=="" || str=="null" || str == null || str == undefined || str == "undefined" ){
      return true;
    } return false;
}

//验证是否为图片格式
function isImg(filename) {
	var ext=filename.substring(filename.lastIndexOf(".")).toUpperCase();
	if(ext!=".BMP"&&ext!=".PNG"&&ext!=".GIF"&&ext!=".JPG"&&ext!=".JPEG"){
      return false;
    } return true
}

//验证是否为空：返回String
function checkNull(str){
    if( str=="" || str=="null" || str == null || str == undefined || str == "undefined" ){
      return "";
    } return str;
}

//验证是否为手机号码
function checkPhone(phone){
    if( checkReg(phone,4) ){
      return phone;
    } return "";
}

/**
 * 注册验证
 * */
function checkReg(val,index){
	var reg;
	switch(index){
		case 0:
		  reg = /^[A-Za-z0-9]{5,20}$/;//字母、数字、5-25（账号）
		  break;
		case 1:
		  reg = /^[A-Za-z0-9]{6,16}$/;//字母、数字、6-16（密码）
		  break;
		case 2:
		  reg = /^[\u4E00-\u9FA5A-Za-z]{2,10}$/;//中英文、2-5（真实姓名）
		  break;  
		case 3:
		  reg = /^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;//email
		  break;
		case 4:
		  reg = /^1[34578]\d{9}$/;//手机号码
		break;    
	}
	return reg.test(val);
}

//验证数字
function checkNum(nubmer){
     var text = /^[0-9]+.?[0-9]*$/;
     if (!text.test(nubmer)){
        return false;
     }  return true;
}

//验证数字，返回parseInt
function checkInt(str){
    if(str==""||str=="null"||str==null||!checkNum(str)||str==undefined){
      return 0;
    } return parseInt(str);
}

//验证数字，返回parseFloat
function checkFloat(str){
    if(str==""||str=="null"||str==null||!checkNum(str)||str==undefined){
      return 0;
    } return parseFloat(str);
}

//input输入数字验证
$(".digit_verify").bind("input propertychange",function(){
     if (!checkNum(this.value)){
        this.value = 1;
     }
});

//4、提示气泡(zwt)
var isAlert = false;
function alertMsg(msg){ 
    if(isAlert){return;}
    isAlert = true;
    var tipsDiv = '<div id="tips-box">'+msg+'</div>';
    $( 'body' ).append( tipsDiv ); 
    $( '#tips-box' ).css('width','64%');
    $( '#tips-box' ).css('height', '2.5em');
    $( '#tips-box' ).css('line-height', '2.5em');
    $( '#tips-box' ).css('background-color', '#000000');
    $( '#tips-box' ).css('border-radius', '0.5em');
    $( '#tips-box' ).css('text-align', 'center');
    $( '#tips-box' ).css('font-size', '0.9em');
    $( '#tips-box' ).css('color', '#FFFFFF');
    $( '#tips-box' ).css('position', 'fixed');
    $( '#tips-box' ).css('top', '36%');
    $( '#tips-box' ).css('right', '18%');
    $( '#tips-box' ).css('opacity', '0.8');
    $( '#tips-box' ).css('filter', 'alpha(opacity=80)');
    $( '#tips-box' ).css('z-index', '980');
    setTimeout( function(){
        $("#tips-box").remove();
        isAlert = false;
    }, ( 1000 ) ); 
} 

//5、获取指定长度code(zwt)
function getRandomCode(len){
    if( len == null || len == undefined || len == "" || len == "null" ){
        len = 8;
    }
  var radix=16;//16进制
  var chars='0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split('');var uuid=[],i;radix=radix||chars.length;if(len){for(i=0;i<len;i++)uuid[i]=chars[0|Math.random()*radix];}else{var r;uuid[8]=uuid[13]=uuid[18]=uuid[23]='-';uuid[14]='4';for(i=0;i<36;i++){if(!uuid[i]){r=0|Math.random()*16;uuid[i]=chars[(i==19)?(r&0x3)|0x8:r];}}}
  return uuid.join('');
}

//6、时间
//6.1、时间处理-时间轴=>年月日格式
function timeStamp2String(time, id) {
	if( isNull(time) == true ){
		return "";
	}
    //y=年;ymd=年月日;ymdhm年月日时分;ymdhms年月日时分秒
    var datetime = new Date();
    datetime.setTime(time);
    var year = datetime.getFullYear();
    var month = datetime.getMonth() + 1 < 10 ? "0" + (datetime.getMonth() + 1) : datetime.getMonth() + 1;
    var month2 = datetime.getMonth() + 1 < 10 ? datetime.getMonth() + 1 : datetime.getMonth() + 1;
    var date = datetime.getDate() < 10 ? "0" + datetime.getDate() : datetime.getDate();
    var date2 = datetime.getDate() < 10 ? datetime.getDate() : datetime.getDate();
    var hour = datetime.getHours() < 10 ? "0" + datetime.getHours() : datetime.getHours();
    var minute = datetime.getMinutes() < 10 ? "0" + datetime.getMinutes() : datetime.getMinutes();
    var second = datetime.getSeconds() < 10 ? "0" + datetime.getSeconds() : datetime.getSeconds();
    if (id == "y") {
        return year;
    } else if (id == "ym") {
        return year + "-" + month;
    } else if (id == "ymd") {
        return year + "-" + month + "-" + date;
    }  else if (id == "ymd2") {
        return year + "年" + month + "月" + date + "日";
    } else if (id == "ymdhm") {
        return year + "-" + month + "-" + date + " " + hour + ":" + minute;
    } else if (id == "ymdhms") {
        return year + "-" + month + "-" + date + " " + hour + ":" + minute + ":" + second;
    } else if (id == "md") {
        return month + "-" + date;
    } else if (id == "hm") {
        return hour + ":" + minute;
    } else if (id == "xs") {
        return hour + ":" + hour;
    } else if (id == "md2") {
        return month2 + "月" + date2 + "日";
    } else if (!id) {
        return year + "-" + month + "-" + date;
    } else if (id == "mdhm") {
        return month + "-" + date + " " + hour + ":" + minute;
    } else if (id == "md3" ) {
        //仿微信
        return "<span>"+month2+"  </span><span style='font-size:.7em;'>"+date2+"日</span>";
    }
}

//6.2、获取当前时间戳：
function getCurrentTimeStamp(){
    return new Date().getTime();
}

//6.3、根据时间戳获取发布时间
function getDateDiff(dateTimeStamp){
	var minute = 1000 * 60;
	var hour = minute * 60;
	var day = hour * 24;
	var halfamonth = day * 15;
	var month = day * 30;
	var now = new Date().getTime();
	var diffValue = now - dateTimeStamp;
	if(diffValue < 0){return;}
	var monthC =diffValue/month;
	var weekC =diffValue/(7*day);
	var dayC =diffValue/day;
	var hourC =diffValue/hour;
	var minC =diffValue/minute;
	if(monthC>=1){
		result="" + parseInt(monthC) + "月前";
	}
	else if(weekC>=1){
		result="" + parseInt(weekC) + "周前";
	}
	else if(dayC>=1){
		result=""+ parseInt(dayC) +"天前";
	}
	else if(hourC>=1){
		result=""+ parseInt(hourC) +"小时前";
	}
	else if(minC>=1){
		result=""+ parseInt(minC) +"分钟前";
	}else
	result="刚刚";
	return result;
}

//6.4、验证是否为日期格式(zwt)
function checkDate(date){
    var reg = /^(\d{4})-(\d{2})-(\d{2})$/;
    var reg1 = /^(\d+)-(\d{1,2})-(\d{1,2}) (\d{1,2}):(\d{1,2})$/;
    var reg2 = /^(\d+)-(\d{1,2})-(\d{1,2}) (\d{1,2}):(\d{1,2}):(\d{1,2})$/;
    if( !reg.test(date) && !reg1.test(date) && !reg2.test(date) ){ 
        return false; 
    }else{
        return true; 
    } 
}

//6.5、时间比较
function compareDate(start,end){
    if(checkDate(start.trim())&&checkDate(end.trim())){
        var a = new Date(start.replace(/-/g,"/"));
        var b = new Date(end.replace(/-/g,"/"));
        if(a<=b){
            return true;
        }else{
            return false;
        }
    }
}

//7、设置默认图片
function getDefaultImage(img,def,path){
	if( isNull(img) ){
		img = def;
	}else{
		if( img.indexOf("http://") < 0 ){
			if( !isNull(path) ){
				img = path + img;
			}else{
				img = appimgPath + img;
			}
		}
	}
	return img;
}

//8、获取字符串中所有img标签
function getImgFromStr(str) {
	var arr = str.match(/<img[^>]+>/g);
	return arr;
}

//9、获取去除所有标签的字符串
function getRemoveTagsStr(str) {
	str = str.replace(/<.*?>/ig,"");
	return str;
}

//10、获取图片原尺寸
function getImgSize(h,w,mh,mw) {
	var size = {"width":0,"height":0};
	if(w>0 && h>0){  
		if( h > w ){
		  if( h > mh ){        
	          size.height = mh;
	          size.width = (mh/h)*w;
	      }else{
	          size.width=w;        
	          size.height=h; 
	      }  
		}else{
		  if( w > mw  ){
	          size.width = mw;
	          size.height = (mw/w)*h; 
	      }else{
	          size.width=w;        
	          size.height=h; 
	      }  
		}
    }  
    return size;
};	

//11、数组

//eg:getInsert(arr)
//arr.insert(2, 'three');
//11.1、获取插入指定位置函数；
function getInsert(Array) {
	Array.prototype.insert = function (index, item) {  
	  this.splice(index, 0, item);  
	}; 
}

//11.2、数组删除元素
function delByEle(ele,arr){
    var index = jQuery.inArray(ele,arr);
	if( index >= 0 ){
		arr.splice(index,1);
	}
}

//11.3、数组进行冒泡排序
function getBubbleSort(array){
    var temp = 0;
    for (var i = 0; i < array.length; i++){
        for (var j = 0; j < array.length - i; j++){
            if (array[j] > array[j + 1]){
                temp = array[j + 1];
                array[j + 1] = array[j];
                array[j] = temp;
            }
        }
    }
    return array;
}

//12、动画（需引入new/common.css）
function addAnimate(id,css,animate) {
	var selector = isNull(id) == false ? "#"+id : "."+css;
	$(selector).addClass(animate);
	setTimeout(function () {
		$(selector).removeClass(animate);
	},350)
}

//13、计步器
/**
 * eg:<textarea id="" onkeyup="pedometer(this,300,'pedometer');"></textarea>
 * */
function pedometer(text,maxlen,id) {
	var val = text.value;
	var curlen = val.length;
	if(curlen > maxlen) {
		text.value = val.substring(0, maxlen);
	} else {
		document.getElementById(id).innerHTML = maxlen - curlen;
	}
}

/******沉浸式状态栏兼容******/
function immersiveById(id,isTrue){
	var immersed = 0;
	var topoffset = 44;
	var ms=(/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
	if(ms && ms.length>=3){ // 当前环境为沉浸式状态栏模式
		immersed = parseFloat(ms[2]);// 获取状态栏的高度
		var obj = document.getElementById(id);
		if( obj ) {
			obj.style.paddingTop = immersed +'px';
			if( isTrue ){
				topoffset = topoffset + immersed;
				obj.style.height= topoffset +'px';
			}
		}
	}
}

/*********用户验证***********/
function verifyUser() {
	var user = getObjStorage("loginUser");  
	if( user ){
		if( isNull(user.COMPANY_NAME) ){
			mui.toast("请完善公司名称");
			return false;
		}else if( isNull(user.POSITION) ){
			mui.toast("请完善任职");
			return false;
		}else if( isNull(user.REAL_NAME) ){
			mui.toast("请完善名称");
			return false;
		} if( isNull(user.PHONE) ){
			mui.toast("请完善手机号码");
			return false;
		}else{
			return true;
		}
	}else{
		mui.toast("请到 我的 登陆账号！");
	    return false;
	}
}

function verifyUserInfo() {
	var user = getObjStorage("loginUser");  
	if( user ){
	    return true;
	}else{
	    return false;
	}
}

/*********等级编码==>等级名称***********/
function getLevelName(bm) {
	var name = "";
	if( bm == "01" ){
		name = "会员";
	}else if(bm == "02"){
		name = "普通会员";
	}else if(bm == "03"){
		name = "副会长";
	}else if(bm == "04"){
		name = "常务副会长";
	}else if(bm == "05"){
		name = "会长";
	}else if(bm == "200"){
		name = "副主席";
	}
	return name;
}

/***************项目状态******************/
function getProStatus(pro) {
	var str = "";
	if( pro ){
		var user = getObjStorage("loginUser"); 
		var status = checkInt(pro.STATUS);
		if( user ){
			if( user.userid == pro.USER_ID ){
				str = status == 1 ? "审核中" : status == 2 ? "审核失败" : status == 3 ? "审核成功" : "";
				if( status == 4 ){
					str = pro.DUE_STATUS == "0" ? "已截止" : "接单中";
				}
			}else{
				if( status == 4 ){
				    str = pro.isBid == "1" ? "已参与" : pro.DUE_STATUS == "0" ? "已截止" : "立即接单";
				}
			}
		}else{
			if( status == 4 ){
				var proParam = getObjStorage("proParam") || [];
				var isCy = false;
				$.each(proParam, function(i,p) {
					if( p && p.PRO_ID == pro.ID ){
						isCy = true;
					}
				});
				str = isCy == true ? "已参与" : pro.DUE_STATUS == "0" ? "已截止" : "立即接单";
			}
		}
		str = status == 5 ? "确认中" : status == 6 ? "交易完成" : str;
	}
	return str;
}

/***************商品订单状态******************/
function getOrderStatus(sta) {
	var str = "";
	if( !isNull(sta) ){
		if( sta == "00" ){
			str = "已下单";
		}else if( sta == "01" ){
			str = "代付款";
		}else if( sta == "02" ){
			str = "代发货";
		}else if( sta == "03" ){
			str = "已发货";
		}else if( sta == "04" ){
			str = "已完成";
		}else if( sta == "05" ){
			str = "已评价";
		}else if( sta == "20" ){
			str = "已取消";
		}
	}else{
		str = "无状态";
	}
	return str;
}

/***************计算升级入会价格******************/
/**
 * lev：升级目标等级；
 * vip：如果已经入会，是否超过三个月，00：超过三个月，01：未超过三个月
 * mylev：用户目前等级
 * **/
function calculatePrice(lev,vip,mylev) {
	var price = -1;//默认价格
	var msg = "成功！";
	var levArr = ["02","01","03","04","05","200"];//等级
	var priceArr = [0,1000,8000,10000,20000,30000];//对应等级的价格
	var index = $.inArray(lev, levArr);
	if( index >= 0 ){
		if( checkNull(vip) == "01" ){
			var myIndex = $.inArray(mylev, levArr);
			if( myIndex >= 0 ){
				price = priceArr[index] - priceArr[myIndex];
			}else{
				msg = "用户等级错误！";
			}
	    }else if( checkNull(vip) == "00" ){
	    	price = priceArr[index];
	    }
	}else{
		msg = "升级等级不存在！";
	}
	return {"price":price,"msg":msg};
}