////////////////////////////////
// Author: Bora DAN — http://codecanyon.net/user/bqra
// 18 August 2013
// E-mail: bora_dan@hotmail.com
////////////////////////////////

$(function () {    
    (function ($) {
        $.fn.jalendar = function (options) {
        	
            var settings = $.extend({
                customDay: new Date(),
                color: '#ffffff',//'#65c2c0',
                lang: 'ZN',
                multi: false,//false:单选，true:多选
                bookArr: [],//已预约日期数组
                dateArr: []//选择日期数组
            }, options);
            
            // Languages            
            var dayNames = {};
            var monthNames = {};
            var lAddEvent = {};
            var lAllDay = {};
            var lTotalEvents = {};
            var lEvent = {};
			dayNames['ZN'] = new Array('一', '二', '三', '四', '五', '六','日');
            dayNames['EN'] = new Array('Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat','Sun');
            dayNames['TR'] = new Array('Pzt', 'Sal', 'Çar', 'Per', 'Cum', 'Cmt','Pzr' );
            dayNames['ES'] = new Array('Lun', 'Mar', 'Mié', 'Jue', 'Vie', 'Såb','Dom'); 
	        monthNames['ZN'] = new Array('一月', '二月', '三月', '四月', '五月', '六月', '七月', '八月', '九月', '十月', '十一月', '十二月'); 
			monthNames['EN'] = new Array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'); 
            monthNames['TR'] = new Array('Ocak', 'Şubat', 'Mart', 'Nisan', 'Mayıs', 'Haziran', 'Temmuz', 'Ağustos', 'Eylül', 'Ekim', 'Kasım', 'Aralık'); 
            monthNames['ES'] = new Array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');  
	        lAddEvent['ZN'] = '新增事件'; 
			lAddEvent['EN'] = 'Add New Event';
            lAddEvent['TR'] = 'Yeni Etkinlik Ekle';
            lAddEvent['ES'] = 'Agregar Un Nuevo Evento'; 
            lAllDay['ZN'] = '全天'; 
			lAllDay['EN'] = 'All Day';
            lAllDay['TR'] = 'Tüm Gün';
            lAllDay['ES'] = 'Todo El Día'; 
            lTotalEvents['ZN'] = '这个月的所有事件: '; 
            lTotalEvents['EN'] = 'Total Events in This Month: ';
            lTotalEvents['TR'] = 'Bu Ayki Etkinlik Sayısı: ';
            lTotalEvents['ES'] = 'Total De Eventos En Este Mes: '; 
            lEvent['ZN'] = 'Event(s)'; 
            lEvent['EN'] = 'Event(s)';
            lEvent['TR'] = 'Etkinlik';
            lEvent['ES'] = 'Evento(s)';
            
            
            var $this = $(this);
            var div = function (e, classN) {
                return $(document.createElement(e)).addClass(classN);
            };
            
            var clockHour = [];
            var clockMin = [];
            for (var i=0;i<24;i++ ){
                clockHour.push(div('div', 'option').text(i))
            }
            for (var i=0;i<59;i+=5 ){
                clockMin.push(div('div', 'option').text(i))
            }
            
            // HTML Tree
            if( settings.multi == false ){
            	$this.append(  
	                div('div', 'jalendar-pages').append( 
	                    div('div', 'header').css('background-color','white').append(
	                        div('a', 'prv-m'),
	                        div('h1','title-color'),
	                        div('a', 'nxt-m'),
	                        div('div', 'day-names')
	                    ), 
	                    div('div', 'days'), 
						div('div', 'clear'),
						div('div', 'get-date').css('background-color','white').append(   
		                    div('div', '').text("您的活动需求？"),
		                    div('div', 'fl').text("活动时间："),
		                    div('div', 'fl start'),
		                    div('div', 'fl end'), 
							div('div', 'fr count').css('color','red')
	                    ) 
	                ) 
	            );
            }else{
            	$this.append(  
	                div('div', 'jalendar-pages').append( 
	                    div('div', 'header').css('background-color','white').append(
	                        div('a', 'prv-m'),
	                        div('h1','title-color'),
	                        div('a', 'nxt-m'),
	                        div('div', 'day-names')
	                    ), 
	                    div('div', 'days'), 
						div('div', 'clear'),
						div('div', 'get-date1').css('background-color','white').append(   
		                    div('div', 'ml-50 fs-t').text("您的活动需求？"),//.css('border','1px solid red')
		                    div('div', 'of-a zoom fs-t').append(
			                    div('div', 'ml-50').text("活动时间："),
			                    div('div', 'datelist ml-50 mr-50'),
								div('div', 'fr count mr-50').css('color','red')
		                    )
	                    ) 
	                ) 
	            );
            }
            
            // Adding day boxes
            for (var i = 0; i < 42; i++) {
                $this.find('.days').append(div('div', 'day'));
            }
            
            // Adding day names fields
            for (var i = 0; i < 7; i++) {
                $this.find('.day-names').append(div('h2').text(dayNames[settings.lang][i]));
            }

            var d = new Date(settings.customDay);
            var year = d.getFullYear();
            var date = d.getDate();
            var month = d.getMonth();
            
            var isLeapYear = function(year1) {
                var f = new Date();
                f.setYear(year1);
                f.setMonth(1);
                f.setDate(29);
                return f.getDate() == 29;
            };
        
            var feb;
            var febCalc = function(feb) { 
                if (isLeapYear(year) === true) { feb = 29; } else { feb = 28; } 
                return feb;
            };
            var monthDays = new Array(31, febCalc(feb), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

            function calcMonth() {

                monthDays[1] = febCalc(feb);
                
                var weekStart = new Date();
                weekStart.setFullYear(year, month, 0);
                var startDay = weekStart.getDay();  
                
                $this.find('.header h1').html(monthNames[settings.lang][month] + ' ' + year);
        
                $this.find('.day').html('&nbsp;');
                $this.find('.day').removeClass('selected').removeAttr('style');
                $this.find('.day').removeClass('this-month');
                $this.find('.day').removeClass("bg-clo-f9");
                for (var i = 1; i <= monthDays[month]; i++) {
                    startDay++;
                    var idate = (parseInt(month)+1) < 10 ? (year+'-0'+(parseInt(month)+1)+'-'+i) : (year+'-'+(parseInt(month)+1)+'-'+i);
                    var index = jQuery.inArray(idate,settings.dateArr);
                    if( index >= 0 ){
                    	$this.find('.day').eq(startDay-1).addClass('selected').css({'background-color':'lightblue'});
                    }
                    
                    var bindex = jQuery.inArray(idate,settings.bookArr);
                    if( bindex >= 0 ){
                    	$this.find('.day').eq(startDay-1).addClass('bg-clo-f9');
                    }
                    
                    var className = '';
                    if( year == d.getFullYear() ){
                    	if( month == d.getMonth() ){
	                    	if( i < date ){
	                    		className = 'this-month bg-clo-f9';
		                    }else{
		                    	className = 'this-month';
		                    }
	                    }else if( month < d.getMonth() ){
	                    	className = 'this-month bg-clo-f9';
	                    }else{
	                    	className = 'this-month';
	                    }
                    }else if( year > d.getFullYear() ){
                    	className = 'this-month';
                    }else{
                    	className = 'this-month bg-clo-f9';
                    }
                    $this.find('.day').eq(startDay-1).addClass(className).attr('data-date', idate).html(i);
                   /* $this.find('.day').eq(startDay-1).addClass('this-month').attr('data-date', i+'/'+(month+1)+'/'+year).html(i);*/
                }
                if ( month == d.getMonth() ) {
                    $this.find('.day.this-month').removeClass('today').eq(date-1).addClass('today').css('color', settings.color);
                } else {
                    $this.find('.day.this-month.today').removeClass('today').attr('style', '');
                }
                calcTotalDayAgain();  
                
            }
            
            calcMonth();
            
            var arrows = new Array ($this.find('.prv-m'), $this.find('.nxt-m'));
            var dropdown = new Array ($this.find('.add-time .select span'), $this.find('.add-time .select .dropdown .option'), $this.find('.add-time .select'));
            var allDay = new Array ('.all-day fieldset[data-type="disabled"]', '.all-day fieldset[data-type="enabled"]');
            var $close = $this.find('.jalendar-wood > .close-button');
            var $erase = $this.find('.event-single .erase');
            $this.find('.jalendar-pages').css({'width' : $this.find('.jalendar-pages').width() });
            $this.find('.events').css('height', ($this.height()-197) );
            $this.find('.select .dropdown .option').hover(function() {
                $(this).css('background-color', settings.color); 
            }, function(){
                $(this).css('background-color', 'inherit'); 
            }); 
            var jalendarWoodW = $this.find('.jalendar-wood').width();
            var woodBottomW = $this.find('.wood-bottom').width();

            // calculate for scroll
            function calcScroll() {
                if ( $this.find('.events-list').height() < $this.find('.events').height() ) { $this.find('.gradient-wood').hide(); $this.find('.events-list').css('border', 'none') } else { $this.find('.gradient-wood').show(); }
            }
            
            // Calculate total event again
            function calcTotalDayAgain() {
                var eventCount = $this.find('.this-month .event-single').length;
                $this.find('.total-bar b').text(eventCount);
                $this.find('.events h3 span b').text($this.find('.events .event-single').length)
            }
            
            function prevAddEvent() {
                //$this.find('.day').removeClass('selected').removeAttr('style');
                $this.find('.today').css('color', settings.color);
                $this.find('.add-event').hide();
                $this.children('.jalendar-wood').animate({'width' : jalendarWoodW}, 200);
                $this.children('.wood-bottom').animate({'width' : woodBottomW}, 200);
                $close.hide();
            }
            
            arrows[1].on('click', function () {
                if ( month >= 11 ) {
                    month = 0;
                    year++;
                } else {
                    month++;   
                }
                calcMonth();
                prevAddEvent();
            });
            arrows[0].on('click', function () {
                dayClick = $this.find('.this-month');
                if ( month === 0 ) {
                    month = 11;
                    year--;
                } else {
                    month--;   
                }
                prevAddEvent();
                calcMonth();
            });
            
            $this.on('click', '.this-month', function () {
            	//小于今天日期不能点击
            	if( $(this).hasClass("bg-clo-f9") ){return;}
            	
                var eventSingle = $(this).find('.event-single')
                $this.find('.events .event-single').remove();
                var id = this.getAttribute('data-date'); 
                if( settings.multi == false ){
                	prevAddEvent();
                	$(this).addClass('selected').css({'background-color':'lightblue'});
                	var startDate=$('.start').text();  
	                if(startDate!=null&&startDate!=''&&startDate!=undefined){ 
	                	var endDate=id;
	                	var startNum = parseInt(startDate.replace(/-/g, ''), 10); 
		                var endNum = parseInt(endDate.replace(/-/g, ''), 10); 
		                if (startNum > endNum) { 
		                    alert("结束时间不能在开始时间之前！"); 
		                    $('.count').text("");
		                }else{
		                	$('.end').text(id); 
		                    var count=DateCompare(startDate,endDate); //计算两个日期之差 
		                    var amount=count+1;
		                    $('.count').text("共"+amount+"天");
		                } 
	                }else{
	                	$('.start').text(id);
	                }  
	                /*$(this).addClass('selected').css({'background-color': settings.color});*/
                }else{
                	if( $(this).hasClass("selected") ){
                		$(this).removeClass("selected").attr('style', '');
                		$('#'+id).remove();
                		if( $('.datelist p').length == 0 ){
                			$('.count').text("");
                		}else{
                			$('.count').text("共"+$('.datelist p').length+"天");
                		}
                		delByEle(id,settings.dateArr);//删除数组元素
                	}else{
                		$(this).addClass('selected').css({'background-color':'lightblue'});
                		$('.datelist').append('<p id="'+id+'" style="float:left;width:75px;margin: 2.5px 0;text-align: center;">'+id+'</p>');
		                $('.count').text("共"+$('.datelist p').length+"天");
		                settings.dateArr.push(id);
                	}
                }
                
            });
            
            $this.on('click', '.start', function () {  
                $('.start').text(""); 
                $('.count').text("");
            });
            $this.on('click', '.end', function () {  
                $('.end').text(""); 
                $('.count').text("");
            }); 
            
            function   DateCompare(asStartDate,asEndDate){   
		      var   miStart=Date.parse(asStartDate.replace(/\-/g,'/')); 
		      var   miEnd=Date.parse(asEndDate.replace(/\-/g,'/')); 
		      return   (miEnd-miStart)/(1000*24*3600); //返回日期相差天数  
		    }

            
            dropdown[0].click(function(){
                dropdown[2].children('.dropdown').hide(0);
                $(this).next('.dropdown').show(0);
            });
            dropdown[1].click(function(){
                $(this).parent().parent().children('span').text($(this).text());
                dropdown[2].children('.dropdown').hide(0);
            });
            $('html').click(function(){
                dropdown[2].children('.dropdown').hide(0); 
            });
            $('.add-time .select span').click(function(event){
                event.stopPropagation(); 
            });
            
            $this.on('click', allDay[0], function(){
                $(this).removeAttr('data-type').attr('data-type', 'enabled').children('.check').children().css('background-color', settings.color);
                dropdown[2].children('.dropdown').hide(0);
                $(this).parents('.all-day').prev('.add-time').css('opacity', '0.4').children('.disabled').css('z-index', '10');
            });
            $this.on('click', allDay[1], function(){
                $(this).removeAttr('data-type').attr('data-type', 'disabled').children('.check').children().css('background-color', 'transparent');
                $(this).parents('.all-day').prev('.add-time').css('opacity', '1').children('.disabled').css('z-index', '-1');
            });
            
            // add new event with panel
            var dataId = parseInt($this.find('.total-bar b').text());
            $this.find('.submit').on('click', function(){
                var title = $(this).prev('input').val();
                var hour = $(this).parents('.add-new').find('.hour > span').text();
                var min = $(this).parents('.add-new').find('.min > span').text();
                var isAllDay = $(this).parents('.add-new').find('.all-day fieldset').attr('data-type');
                var isAllDayText = $(this).parents('.add-new').find('.all-day fieldset label').text();
                var thisDay = $this.find('.day.this-month.selected').attr('data-date');
                var time;
                if ( isAllDay == 'disabled' ) {
                    time = hour + ':' + min;
                } else {
                    time = isAllDayText;
                }
                $this.prepend(div('div', 'added-event').attr({'data-date':thisDay, 'data-time': time, 'data-title': title, 'data-id': dataId}));
                
                $this.find('.day.this-month.selected').prepend(
                    div('div','event-single').attr('data-id', dataId).append(
                        div('p','').text(title),
                        div('div','details').append(
                            div('div', 'clock').text(time),
                            div('div', 'erase')
                        )
                    )
                );
                $this.find('.day').has('.event-single').addClass('have-event').prepend(div('i',''));
                $this.find('.events-list').html($this.find('.day.this-month.selected .event-single').clone())
                $this.find('.events-list .event-single').eq(0).hide().slideDown();
                calcTotalDayAgain();
                calcScroll();
                // scrolltop after adding new event
                $this.find('.events-list').scrollTop(0);
                // form reset
                $this.find('.add-new > input[type="text"]').val(lAddEvent[settings.lang]).select();
                dataId++;
            });
            
            $close.on('click', function(){
                prevAddEvent(); 
            });
            
            // delete event
            $this.on('click', '.event-single .erase', function(){
                $('div[data-id=' + $(this).parents(".event-single").attr("data-id") + ']').animate({'height': 0}, function(){ 
                    $(this).remove();
                    calcTotalDayAgain();
                    calcScroll();
                });
            });

        };

    }(jQuery));

});

