var shopApp=angular.module('shopApp',[]);  
var pageSize=8;

shopApp.controller('shopController',function($scope,$http){ 
	$scope.imgPath=imgPath;  
	$scope.appimgPath=appimgPath;  
	
    //分页参数
    $scope.currentPage=1;     //页码:第二页开始
    $scope.pageSize=pageSize; //条数
    $scope.sliderFlag = false;
    
    /**店铺ID**/
    var SHOP_ID = getStorage("SHOP_ID");
	$scope.initLoad=function(){ 
		var token=localStorage.getItem("token");
        var userInfo = getObjStorage("loginUser") || {};
		//接口参数
		var param={"SHOP_ID":SHOP_ID,"USER_ID":checkNull(userInfo.userid)};
		console.log("param:"+JSON.stringify(param));

	    angularPost($http,  
	    {
			InterfaceId: '2017130',
			Token: token,
			params: Encrypt(JSON.stringify(param)), 
      		md5_str: faultylabs.MD5(JSON.stringify(param)),
			timestamp:''
	    },
		function(data){ 
			console.log("查询成功！"+data.result); 
			var res = angular.fromJson(data.result); 
			initShop(res);
		},function(){
			console.log("失败");
		});  
	} 
	$scope.initLoad();
	
	function initShop(data) {
		if( data ){
			if( data.isCollect == "1" ){
				$("#collect").find(".cy-search-right-img").removeClass("collect").addClass("collect-hover");
			}
			var SHOP_THEME = getDefaultImage(data.SHOP_THEME,"../../images/60x60.gif",imgPath);
			$("#SHOP_THEME").css("background-image","url("+SHOP_THEME+")");
			var SHOP_PORTRALT = getDefaultImage(data.SHOP_PORTRALT,"../../images/60x60.gif",imgPath);
			$("#SHOP_PORTRALT").attr("src",SHOP_PORTRALT);
			$("#SHOP_NAME").text(checkNull(data.SHOP_NAME));
			$("#VIP_LEVEL").text(getLevelName(data.VIP_LEVEL));
			initData(data.products);
		}
	}
	
	$scope.loadMore=function(){ 
		var token=localStorage.getItem("token");
		//接口参数
		var param={
			"SHOP_ID":SHOP_ID,
			"currentPage":$scope.currentPage,
			"pageSize":$scope.pageSize
		};
		//商品名称
		var PROD_NAME = $("#search").val();
		param.PROD_NAME=PROD_NAME;
		
		var SALE_N = null;
		var CREATE_DATE = null;
		var PRICE = null;
		var id = $(".dp-dt-act").attr("id");
		if( id == "SALE_N" ){
			param.SALE_N=id;
		}else if( id == "CREATE_DATE" ){
			param.CREATE_DATE=id;
		}else if( id == "PRICE" ){
			var flag = $(".dp-dt-act").attr("flag");
			param.PRICE=checkInt(flag);
		}
		console.log("param:"+JSON.stringify(param));

	    angularPost($http,  
	    {
			InterfaceId: '2017127',
			Token: token,
			params: Encrypt(JSON.stringify(param)), 
      		md5_str: faultylabs.MD5(JSON.stringify(param)),
			timestamp:''
	    },
		function(data){ 
			console.log("查询成功！"+data.result); 
			var res = angular.fromJson(data.result); 
			initData(res);
		},function(){
			console.log("失败");
		});  
	} 
	
    var isClick = false;
    function initData(data) {
    	if( !data || data.length == 0 ){
    		$scope.sliderFlag = true;
    	}else{
    		/**计算图片宽高**/
    		var win_width = $(window).width();
			var div_width = (win_width-15)/2;
			var img_width = div_width-10;
			
	    	var dataList = '';
	    	$.each(data,function(i,d) {
    			var img = getDefaultImage(d.PROD_HEAD,"../../images/60x60.gif",imgPath);
    			dataList += '<div id="'+d.ID+'" class="cy-li" style="width:'+div_width+'px;">'
								+ '<div class="cy-li-img" style="height:'+img_width+'px;"><img src="'+img+'" alt=""></div>'
								+ '<div class="cy-li-text">'
									+ '<div class="cy-li-top">'+checkNull(d.PROD_NAME)+'</div>'
									+ '<div class="cy-li-bottom">'
										+ '<div class="cy-li-bottom-left">￥'+checkFloat(d.PRICE)+'</div>'
										+ '<div class="cy-li-bottom-right">月销 '+checkInt(d.SALE_N)+'笔</div>'
									+ '</div>'
								+ '</div>'
							+ '</div>';		
	    	})
			if( $scope.currentPage == 1 ){
				$("#dataList").html(dataList);
			}else{
				$("#dataList").append(dataList);
			}
			
			//朋友圈详情页
			$("#dataList .cy-li").on("tap",function(){ 
				if( isClick == true ) return;
			    isClick = true;
			    
			    var id = this.getAttribute("id");
			    setStorage("PROD_ID",id);
			    var commodity = plus.webview.getWebviewById("commodity.html");
			    if( commodity ){
			    	/**h5重新创建商品页面**/
			    	var page = plus.webview.create("commodity.html", id);
			    	page.show("slide-in-right", 300);
			    }else{
			    	toUrl("commodity.html");
			    }
				
				setTimeout(function () {
					isClick = false;
				},500);
			});
    	}
    }
    
    /**搜索**/
    $scope.search=function(val){ 
		var token=localStorage.getItem("token");
		//接口参数
		var param={
			"SHOP_ID":SHOP_ID,
			"PROD_NAME":val,
			"currentPage":$scope.currentPage,
			"pageSize":$scope.pageSize
		};
		console.log("param:"+JSON.stringify(param));

	    angularPost($http,  
	    {
			InterfaceId: '2017127',
			Token: token,
			params: Encrypt(JSON.stringify(param)), 
      		md5_str: faultylabs.MD5(JSON.stringify(param)),
			timestamp:''
	    },
		function(data){ 
			console.log("查询成功！"+data.result); 
			var res = angular.fromJson(data.result); 
			initData(res);
		},function(){
			console.log("失败");
		});  
	} 
    
    /**收藏店铺**/
    //收藏
    var isCollect = false;
    $scope.collect=function(){ 
    	var token=localStorage.getItem("token");
    	var userInfo = getObjStorage("loginUser") || {};
    	if( isNull(userInfo.userid) ){
    		var btnArray = ['确认', '取消']; 
			mui.confirm('您还未登录，请先登录', '温馨提示', btnArray, function(e) { 
                if (e.index == 0) { 
                	var login = plus.webview.getWebviewById("login");
	            	if( login ){
	            		login.show();
	            	}else{
	            		mui.openWindow({
							url: "../../login.html",
							id: "login"
						});
	            	}
                }
                setTimeout(function () {
	                isCollect = false;
	            },500);
            }); 
    		return;
    	}
		//接口参数
		var param={
			"USER_ID":userInfo.userid,
			"OBJECT_ID":SHOP_ID,
			"TYPE":"JL_DP_SHOP"
		};
		console.log("param:"+JSON.stringify(param));

	    angularPost($http,  
	    {
			InterfaceId: '2017006',
			Token: token,
			params: Encrypt(JSON.stringify(param)), 
      		md5_str: faultylabs.MD5(JSON.stringify(param)),
			timestamp:''
	    },
		function(data){ 
			isCollect = false;
			console.log("操作成功！"+data.result); 
			var res = angular.fromJson(data.result); 
			if( res && res.code == "200" ){
				mui.toast("操作成功");
				var flag = 0;//0、收藏数量减一，1收藏数量加一；
				if( $("#collect").find(".cy-search-right-img").hasClass("collect") ){
					$("#collect").find(".cy-search-right-img").removeClass("collect").addClass("collect-hover");
					flag = 1;
				}else{
					$("#collect").find(".cy-search-right-img").removeClass("collect-hover").addClass("collect");
				    flag = 0;
				}
				
				/**修改公司详情页店铺收藏数量**/
				var gsxq = plus.webview.getWebviewById("gongsixq.html");
				if( gsxq ){
					gsxq.evalJS("amendCollectNum("+flag+")");
				}
			}else{
				mui.toast("操作失败");
			}
		},function(){
			console.log("操作失败");
		});  
	}
}); 
 